//use "C:\Users\134476.SCIENCESPO\C DE CHAISEMARTIN Dropbox\clément de chaisemartin\Cours\Mini course DID\Applications\Data sets\Moser and Voena 2012\moser_voena_didtextbook.dta", clear

use "C:\Users\fe-kn\C DE CHAISEMARTIN Dropbox\RAs De Chaisemartin\Mini course DID\Applications\Data sets\Moser and Voena 2012\moser_voena_didtextbook.dta", clear

*** 1) Static TWFE regression
 
xtreg patents twea i.year, fe i(subclass)
reghdfe patents twea, absorb(subclass year)

sum patents if treatmentgroup==1&post==1

*** 2) Equivalence between static TWFE regression and DID
 
reg patents treatmentgroup post twea, cluster(subclass)

*** 3) Testing randomized treatment

reg patents treatmentgroup if year<=1918, cluster(subclass)

*** 4) Event-study TWFE regression
 
reg patents i.year treatmentgroup reltimeminus* reltimeplus*, cluster(subclass)

test reltimeminus1 reltimeminus2 reltimeminus3 reltimeminus4 reltimeminus5 reltimeminus6 reltimeminus7 reltimeminus8 reltimeminus9 reltimeminus10 reltimeminus11 reltimeminus12 reltimeminus13 reltimeminus14 reltimeminus15 reltimeminus16 reltimeminus17 reltimeminus18

* Generating corresponding ES plot
{
/* We produce the E-S graph by creating a matrix (res) gathering the time to the 
event, the point estimates and the CI */

reg patents reltimeminus* reltimeplus* i.year treatmentgroup, cluster(subclass)

matrix temp=r(table)'
matrix res=J(40,4,0)
matrix res[19,1]=0
forvalues x = 1/18 {
matrix res[19-`x',1]=-`x'
matrix res[19-`x',2]=temp[`x',1]
matrix res[19-`x',3]=temp[`x',5]
matrix res[19-`x',4]=temp[`x',6]
}
forvalues x = 1/21 {
matrix res[`x'+19,1]=`x'
matrix res[`x'+19,2]=temp[`x'+18,1]
matrix res[`x'+19,3]=temp[`x'+18,5]
matrix res[`x'+19,4]=temp[`x'+18,6]
}

// Store sub matrix for the figure with the Borusyak et al estimator
matrix res_post=res["r19".."r40","c1".."c4"]

preserve
drop _all
svmat res
twoway (scatter res2 res1, msize(medlarge) msymbol(o) mcolor(navy) legend(off)) ///
	(line res2 res1, lcolor(navy)) (rcap res4 res3 res1, lcolor(maroon)), ///
	 title("TWFE Event-study estimates") xtitle("Relative time to year before TWEA") ///
	 ytitle("Effect") xlabel(-18(3)21) yscale(range(-0.25 1)) ylabel(-0.25(.25)1)
graph export "C:\Users\fe-kn\C DE CHAISEMARTIN Dropbox\RAs De Chaisemartin\Mini course DID\Applications\Solutions\Moser and Voena 2012\graphs\graphES_moser1.pdf", replace
restore
}

*** 5) Event-study TWFE regression, without pre-trends estimates

reg patents i.year treatmentgroup reltimeplus*, cluster(subclass)

* Generating corresponding ES plot
{
reg patents reltimeplus* i.year treatmentgroup, cluster(subclass)

matrix temp=r(table)'
matrix res=J(22,4,0)
matrix res[1,1]=0
forvalues x = 1/21 {
matrix res[`x'+1,1]=`x'
matrix res[`x'+1,2]=temp[`x',1]
matrix res[`x'+1,3]=temp[`x',5]
matrix res[`x'+1,4]=temp[`x',6]
}

preserve
drop _all
svmat res
svmat res_post
twoway (scatter res2 res1, msize(small) msymbol(o) mcolor(midblue) legend(order(2 /*"  &" 3*/ "Without Pre-Periods" 4 /*"  &" 5*/ "With Pre-Periods") pos(6) col(2))) ///
	(line res2 res1, lcolor(midblue)) (rcap res4 res3 res1, lcolor(midblue)) ///
	(line res_post2 res1, lcolor(red)) (rcap res_post4 res_post3 res1, lcolor(red)) ///
	(scatter res_post2 res1, msize(small) msymbol(o) mcolor(red)), ///
	 title("TWFE Event-study estimates") xtitle("Relative time to year before TWEA") ///
	 ytitle("Effect") xlabel(0(3)21) yscale(range(-0.25 1)) ylabel(-0.25(.25)1)
graph export "C:\Users\fe-kn\C DE CHAISEMARTIN Dropbox\RAs De Chaisemartin\Mini course DID\Applications\Solutions\Moser and Voena 2012\graphs\graphES_moser2.pdf", replace
restore
}

*** 6) Linear pre-trends we could fail to detect

*Estimation based on our first 6 pre-trends estimates only, because otherwise command takes too long to run.
local github https://raw.githubusercontent.com
net install pretrends, from(`github'/mcaceresb/stata-pretrends/main) replace
reghdfe patents reltimeminus* reltimeplus*, absorb(treatmentgroup year) cluster(subclass)
pretrends power 0.5, numpre(6)

* Generating corresponding ES plot
{
local slope=r(slope)	
	
preserve
	
keep if year>=1912&year<=1939
drop reltimeminus7-reltimeminus18
	
reg patents reltimeminus* reltimeplus* i.year treatmentgroup, cluster(subclass)

restore 

matrix temp=r(table)'
matrix res=J(28,4,0)
matrix res[7,1]=0
forvalues x = 1/6 {
matrix res[7-`x',1]=-`x'
matrix res[7-`x',2]=temp[`x',1]
matrix res[7-`x',3]=temp[`x',5]
matrix res[7-`x',4]=temp[`x',6]
}
forvalues x = 1/21 {
matrix res[`x'+7,1]=`x'
matrix res[`x'+7,2]=temp[`x'+6,1]
matrix res[`x'+7,3]=temp[`x'+6,5]
matrix res[`x'+7,4]=temp[`x'+6,6]
}

preserve
drop _all
svmat res
twoway (scatter res2 res1, msize(medlarge) msymbol(o) mcolor(navy) legend(off)) ///
	(line res2 res1, lcolor(navy)) (rcap res4 res3 res1, lcolor(maroon)) (function y=x*`slope', range(-6 21) lcolor(gray) lpattern(dash)), ///
	 title("TWFE Event-study estimates") xtitle("Relative time to year before TWEA") ///
	 ytitle("Effect") xlabel(-6(3)21) yscale(range(-0.25 1)) ylabel(-0.25(.25)1)
graph export "C:\Users\fe-kn\C DE CHAISEMARTIN Dropbox\RAs De Chaisemartin\Mini course DID\Applications\Solutions\Moser and Voena 2012\graphs\graphES_moser3.pdf", replace
restore
}

*** 7) The variance of the effect of having been exposed to treatment for 14 years

sdtest diffpatentswrt1918 if year==1932, by(treatmentgroup)
di r(sd_2)-r(sd_1)
scalar sd_effects=r(sd_2)-r(sd_1)
reg diffpatentswrt1918 treatmentgroup if year==1932
di _b[treatmentgroup]-1.96*sd_effects,_b[treatmentgroup]+1.96*sd_effects

*** 8) Placebo test of the assumptions underlying the estimation of the variance of treatment effects

sdtest diffpatentswrt1918 if year==1904, by(treatmentgroup)

forvalue i=1900/1939{
sdtest diffpatentswrt1918 if year==`i', by(treatmentgroup)
}


